%define upstream_name    PDL
%define upstream_version 2.015

%define Werror_cflags %nil

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 5

Summary:    PerlDL, an efficient numerical language for scientific computing
License:    GPL
Group:      Development/Perl
Url:        http://search.cpan.org/dist/%{upstream_name}/
Source0:    http://cpan.metacpan.org/authors/id/C/CH/CHM/%{upstream_name}-%{upstream_version}.tar.gz
Source1:    PDL-convert-doc.pl.bz2
Patch1:     PDL-2.4.4-fpic.patch
Patch2:     PDL-2.4.4-handle-INSTALLDIRS-vendor.patch
# Hacks for fixing writing permissions
Patch3:     PDL-2.012-direct-pod2html-to-writable-directory_and_make_html_files_writable.patch
Patch4:     PDL-2.4.0-fix-gimp.patch
Patch5:     PDL-2.4.2-makemakerfix.patch
# Remove Proj stiff which is not built but breaks doc building
Patch6:     PDL-2.007-no-Proj.patch
Patch7:     PDL-2.007-gsl2.patch

BuildRequires: perl(Astro::FITS::Header)
BuildRequires: perl(CPAN::Meta) >= 2.120.900
BuildRequires: perl(Carp)
BuildRequires: perl(Config)
BuildRequires: perl(Convert::UU)
BuildRequires: perl(Data::Dumper) >= 2.121.0
BuildRequires: perl(Devel::CheckLib) >= 1.10.0
BuildRequires: perl(English)
BuildRequires: perl(ExtUtils::MakeMaker) >= 6.560.0
BuildRequires: perl(ExtUtils::Manifest)
BuildRequires: perl(ExtUtils::ParseXS) >= 3.10.0
BuildRequires: perl(Fcntl)
BuildRequires: perl(File::Basename)
BuildRequires: perl(File::Find)
BuildRequires: perl(File::Map) >= 0.570.0
BuildRequires: perl(File::Path)
BuildRequires: perl(File::Spec) >= 0.600.0
BuildRequires: perl(File::Temp)
BuildRequires: perl(Filter::Simple) >= 0.880.0
BuildRequires: perl(Filter::Util::Call)
BuildRequires: perl(IPC::Cmd) >= 0.720.0
BuildRequires: perl(Inline) >= 0.680.0
BuildRequires: perl(Inline::C) >= 0.620.0
BuildRequires: perl(Module::Compile) >= 0.230.0
BuildRequires: perl(OpenGL) >= 0.670.200
BuildRequires: perl(Pod::Parser)
BuildRequires: perl(Pod::Select)
BuildRequires: perl(Scalar::Util)
BuildRequires: perl(Storable) >= 1.30.0
BuildRequires: perl(Test::Deep)
BuildRequires: perl(Test::Exception)
BuildRequires: perl(Test::Warn)
BuildRequires: perl(Text::Balanced) >= 1.890.0
BuildRequires: gcc-gfortran
BuildRequires: libgsl-devel
BuildRequires: mesaglu-devel
BuildRequires: freeglut-devel
BuildRequires: ncurses-devel
BuildRequires: perl-devel
BuildRequires: perl-ExtUtils_F77 >= 1.14-11mdk
BuildRequires: libx11-devel
BuildRequires: libxext-devel
BuildRequires: libxi-devel
BuildRequires: libxmu-devel
# if installed, requires f2c-devel,
# but it is a contrib package
BuildConflicts: f2c

Provides:   perl(PDL::PP::CType)
Provides:   perl(PDL::PP::Dims)
Provides:   perl(PDL::PP::PDLCode)
Provides:   perl(PDL::PP::SymTab)
Provides:   perl(PDL::PP::XS)
Provides:   perl(PDL::Config)
Provides:   perl(PDL::Graphics::OpenGL)
Provides:   perl(PDL::Graphics::OpenGLQ)
Provides:   perl(PDL::Graphics::TriD::GL)
Provides:   perl(PDL::Graphics::TriD::Objects)
Provides:   perl()
Provides:   perl(PDL::Lite)
Provides:   perl(PDL::LiteF)
Provides:   perl(PGPLOT)

Obsoletes:  PDL
Provides:   PDL

%{?perl_default_filter}
#global __provides_exclude perl\\(Inline\\)
#global __requires_exclude perl\\((Devel::REPL::Plugin|Inline|PDL|PDL::Demos::Screen|PDL::Graphics::Gnuplot|PDL::Graphics::TriD|PDL::Graphics::TriD::Image|PDL::IO::HDF::SD|PDL::IO::HDF::VS|PDL::Graphics::Gnuplot|PGPLOT|Prima::MsgBox)\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\((OpenGL::Config|PDL::Demos::Screen|(Prima[A-Za-z:_]*)|Tk|Win32::DDE::Client)\\)$
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(Inline\\)$
%global __provides_exclude %__provides_exclude|^perl\\(Win32.*\\)$
# Remove under-specified dependencies
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\((%%s|Data::Dumper|File::Spec|Filter::Simple|Inline|Module::Compile|OpenGL|Text::Balanced)\\)$

%description

%package    doc
Summary:    PerlDL documentation package
Group:      Documentation
Requires:   perl-PDL
%description
The perlDL project aims to turn perl into an efficient numerical language for
scientific computing. The PDL module gives standard perl the ability to
COMPACTLY store and SPEEDILY manipulate the large N-dimensional data sets which
are the bread and butter of scientific computing. e.g. C<$a=$b+$c> can add two
2048x2048 images in only a fraction of a second.

The aim is to provide tons of useful functionality for
scientific and numeric analysis.

%description    doc
The perlDL project aims to turn perl into an efficient numerical language for
scientific computing. The PDL module gives standard perl the ability to
COMPACTLY store and SPEEDILY manipulate the large N-dimensional data sets which
are the bread and butter of scientific computing. e.g. C<$a=$b+$c> can add two
2048x2048 images in only a fraction of a second.

The aim is to provide tons of useful functionality for
scientific and numeric analysis.

This is the documentation package.

%prep
%setup -q -n %{upstream_name}-%{upstream_version}
%patch1 -p1 -b .pic
%patch2 -p1 -b .vendor
%patch3 -p1 -b .writable-cachedir
%patch4 -p0 -b .gimp
%patch5 -p0 -b .mm
%patch6 -p1 -b .proj
%patch7 -p1 -b .gsl2

%build
echo | %__perl Makefile.PL INSTALLDIRS=vendor PREFIX=%{_prefix} OPTIMIZE="%{optflags}"
make

# first generate blib/lib/PDL/pdldoc.db
make doctest

%install
%makeinstall PREFIX="%{buildroot}/%{_prefix}"

# create /usr/bin if it doesn't already exist
%__mkdir_p %{buildroot}%{_bindir}

# fix installed documentation
%__bzip2 -dc %{SOURCE1} | %__perl - "%{buildroot}"

#fix permission
chmod 0755 %buildroot/usr/bin/pdl
#chmod 0755 %buildroot/usr/lib/perl5/vendor_perl/5.22.3/x86_64-linux-thread-multi/auto/PDL/GSL/DIFF/DIFF.so
find %{buildroot} -type f -name *.so -exec chmod 0755 {} \;

%files
%doc COPYING Changes DEPENDENCIES DEVELOPMENT Demos Example GENERATED INSTALL INTERNATIONALIZATION IO META.json META.yml MYMETA.yml README TODO
%doc DEVELOPMENT INSTALL
%{_bindir}/*
%{_mandir}/*/*
%{perl_vendorarch}/PDL.pm
%{perl_vendorarch}/PDL
%{perl_vendorarch}/auto/PDL
%{perl_vendorarch}/Inline
%exclude %{perl_vendorarch}/PDL/*.pod
%exclude %{perl_vendorarch}/PDL/HtmlDocs

%files doc
%doc COPYING
%{perl_vendorarch}/PDL/*.pod
%{perl_vendorarch}/PDL/HtmlDocs


%changelog
* Tue Sep 12 2017 bb2 <bb2> - 2.15.0-5pclos2017
- rebuild against updates

* Mon Sep 04 2017 bb2 <bb2> - 2.15.0-4pclos2017
- rebuild new gcc

* Wed Jul 12 2017 bb2 <bb2> - 2.15.0-3pclos2017
- rebuild against updates

